############ TCL FILE ######################################
# USER AND DATE STAMP
############################################################

  set cam_post_dir [MOM_ask_env_var UGII_CAM_POST_DIR]
  set cam_debug_dir [MOM_ask_env_var UGII_CAM_DEBUG_DIR]
  source ${cam_post_dir}ugpost_base.tcl

proc MOM_before_each_add_var {} {}
proc MOM_before_each_event {} {}

#  source ${cam_debug_dir}mom_review.tcl

  MOM_set_debug_mode OFF

########## SYSTEM VARIABLE DECLARATIONS ##############
  set mom_sys_rapid_code                        "0"
  set mom_sys_linear_code                       "1"
  set mom_sys_circle_code(CLW)                  "2"
  set mom_sys_circle_code(CCLW)                 "3"
  set mom_sys_lathe_thread_advance_type(1)      "33"
  set mom_sys_lathe_thread_advance_type(2)      "34"
  set mom_sys_lathe_thread_advance_type(3)      "35"
  set mom_sys_delay_code(SECONDS)               "4"
  set mom_sys_delay_code(REVOLUTIONS)           "4"
  set mom_sys_cutcom_code(OFF)                  "40"
  set mom_sys_cutcom_code(LEFT)                 "41"
  set mom_sys_cutcom_code(RIGHT)                "42"
  set mom_sys_adjust_code                       "43"
  set mom_sys_adjust_code_minus                 "44"
  set mom_sys_adjust_cancel_code                "49"
  set mom_sys_unit_code(IN)                     "20"
  set mom_sys_unit_code(MM)                     "21"
  set mom_sys_cycle_drill_break_chip_code       "73"
  set mom_sys_cycle_off                         "80"
  set mom_sys_cycle_drill_code                  "81"
  set mom_sys_cycle_drill_deep_code             "83"
  set mom_sys_cycle_drill_dwell_code            "82"
  set mom_sys_cycle_tap_code                    "84"
  set mom_sys_cycle_bore_code                   "85"
  set mom_sys_output_code(ABSOLUTE)             "90"
  set mom_sys_output_code(INCREMENTAL)          "91"
  set mom_sys_reset_code                        "50"
  set mom_sys_feed_rate_mode_code(IPM)          "94"
  set mom_sys_feed_rate_mode_code(IPR)          "95"
  set mom_sys_feed_rate_mode_code(FRN)          "93"
  set mom_sys_spindle_mode_code(SFM)            "96"
  set mom_sys_spindle_mode_code(RPM)            "97"
  set mom_sys_return_code                       "28"
  set mom_sys_cycle_ret_code(AUTO)              "98"
  set mom_sys_cycle_ret_code(MANUAL)            "99"
  set mom_sys_feed_rate_mode_code(MMPM)         "94"
  set mom_sys_feed_rate_mode_code(MMPR)         "95"
  set mom_sys_program_stop_code                 "0"
  set mom_sys_optional_stop_code                "1"
  set mom_sys_end_of_program_code               "2"
  set mom_sys_spindle_direction_code(CLW)       "3"
  set mom_sys_spindle_direction_code(CCLW)      "4"
  set mom_sys_spindle_direction_code(OFF)       "5"
  set mom_sys_tool_change_code                  "6"
  set mom_sys_coolant_code(MIST)                "7"
  set mom_sys_coolant_code(ON)                  "8"
  set mom_sys_coolant_code(FLOOD)               "8"
  set mom_sys_coolant_code(OFF)                 "9"
  set mom_sys_rewind_code                       "30"
  set mom_sys_sim_cycle_drill                   "0"
  set mom_sys_sim_cycle_drill_dwell             "0"
  set mom_sys_sim_cycle_drill_deep              "0"
  set mom_sys_sim_cycle_drill_break_chip        "0"
  set mom_sys_sim_cycle_tap                     "0"
  set mom_sys_sim_cycle_bore                    "0"
  set mom_sys_cir_vector                        "Vector - Arc Center to Start"
  set mom_sys_spindle_max_rpm_code              "92"
  set mom_sys_spindle_cancel_sfm_code           "93"
  set mom_sys_spindle_ranges                    "0"
  set mom_sys_delay_output_mode                 "SECONDS"
  set mom_sys_rewind_stop_code                  "%"
  set mom_sys_home_pos(0)                       "0"
  set mom_sys_home_pos(1)                       "0"
  set mom_sys_home_pos(2)                       "0"
  set mom_sys_zero                              "0"
  set mom_sys_opskip_block_leader               "/"
  set mom_sys_seqnum_start                      "10"
  set mom_sys_seqnum_incr                       "10"
  set mom_sys_seqnum_freq                       "1"
  set mom_sys_seqnum_max                        "9999"
  set mom_sys_lathe_x_double                    "2"
  set mom_sys_lathe_x_factor                    "1"
  set mom_sys_lathe_z_factor                    "1"
  set mom_sys_leader(N)                         "N"
  set mom_sys_leader(X)                         "X"
  set mom_sys_leader(Y)                         "Y"
  set mom_sys_leader(Z)                         "Z"
  set mom_sys_head_code(INDEPENDENT)            "21"
  set mom_sys_head_code(DEPENDENT)              "22"
  set mom_sys_turret_index(INDEPENDENT)         "1"
  set mom_sys_turret_index(DEPENDENT)           "2"
  set mom_sys_delay_param(SECONDS,format)       "Dwell_SECONDS"
  set mom_sys_delay_param(REVOLUTIONS,format)   "Dwell_REVOLUTIONS"
  set mom_sys_contour_feed_mode(LINEAR)         "MMPM"
  set mom_sys_rapid_feed_mode(LINEAR)           "MMPM"
  set mom_sys_cycle_feed_mode                   "MMPM"
  set mom_sys_feed_param(IPM,format)            "Feed_IPM"
  set mom_sys_feed_param(IPR,format)            "Feed_IPR"
  set mom_sys_feed_param(FRN,format)            "Feed_INV"
  set mom_sys_feed_param(MMPM,format)           "Feed_MMPM"
  set mom_sys_feed_param(MMPR,format)           "Feed_MMPR"
  set mom_sys_control_out                       "("
  set mom_sys_control_in                        ")"

####### KINEMATIC VARIABLE DECLARATIONS ##############
  set mom_kin_arc_output_mode                   "FULL_CIRCLE"
  set mom_kin_arc_valid_planes                  "XZ"
  set mom_kin_clamp_time                        "2.0"
  set mom_kin_dependent_head                    "NONE"
  set mom_kin_flush_time                        "2.0"
  set mom_kin_ind_to_dependent_head_x           "0"
  set mom_kin_ind_to_dependent_head_z           "0"
  set mom_kin_independent_head                  "NONE"
  set mom_kin_linearization_flag                "TRUE"
  set mom_kin_linearization_tol                 "0.001"
  set mom_kin_machine_resolution                "0.001"
  set mom_kin_machine_type                      "lathe"
  set mom_kin_max_arc_radius                    "99999.999"
  set mom_kin_max_fpm                           "10000"
  set mom_kin_max_fpr                           "1000"
  set mom_kin_max_frn                           "99999.999"
  set mom_kin_min_arc_length                    "0.001"
  set mom_kin_min_arc_radius                    "0.001"
  set mom_kin_min_fpm                           "1.0"
  set mom_kin_min_fpr                           "0.001"
  set mom_kin_min_frn                           "0.001"
  set mom_kin_output_unit                       "MM"
  set mom_kin_pivot_gauge_offset                "0.0"
  set mom_kin_post_data_unit                    "MM"
  set mom_kin_rapid_feed_rate                   "10000"
  set mom_kin_tool_change_time                  "12.0"
  set mom_kin_x_axis_limit                      "1000"
  set mom_kin_y_axis_limit                      "1000"
  set mom_kin_z_axis_limit                      "1000"

####  Listing File variables
  set mom_sys_list_output                       "ON"
  set mom_sys_header_output                     "ON"
  set mom_sys_list_file_rows                    "120"
  set mom_sys_list_file_columns                 "80"
  set mom_sys_warning_output                    "OFF"
  set mom_sys_group_output                      "OFF"
  set mom_sys_list_file_suffix                  "lpt"
  set mom_sys_output_file_suffix                "ptp"
  set mom_sys_commentary_output                 "ON"
  set mom_sys_commentary_list                   "x z feed speed"




#=============================================================
proc MOM_start_of_program { } {
#=============================================================
  global mom_logname mom_date is_from
  global mom_coolant_status mom_cutcom_status
  global mom_clamp_status mom_cycle_status
  global mom_spindle_status mom_cutcom_plane pb_start_of_program_flag
  global mom_cutcom_adjust_register mom_tool_adjust_register
  global mom_tool_length_adjust_register mom_length_comp_register
  global mom_flush_register mom_wire_cutcom_adjust_register

    set pb_start_of_program_flag 0
    set mom_coolant_status UNDEFINED
    set mom_cutcom_status  UNDEFINED
    set mom_clamp_status   UNDEFINED
    set mom_cycle_status   UNDEFINED
    set mom_spindle_status UNDEFINED
    set mom_cutcom_plane   UNDEFINED

    catch {unset mom_cutcom_adjust_register}
    catch {unset mom_tool_adjust_register}
    catch {unset mom_tool_length_adjust_register}
    catch {unset mom_length_comp_register}
    catch {unset mom_flush_register}
    catch {unset mom_wire_cutcom_adjust_register}

    set is_from ""

    OPEN_files ; #open warning and listing files
    LIST_FILE_HEADER ; #list header in commentary listing
}


#=============================================================
proc MOM_before_motion { } {
#=============================================================
  global mom_motion_event mom_motion_type

    FEEDRATE_SET

    switch $mom_motion_type {
      ENGAGE   {PB_engage_move}
      APPROACH {PB_approach_move}
      FIRSTCUT {PB_first_cut}
    }

    if [llength [info commands PB_CMD_kin_before_motion] ] { PB_CMD_kin_before_motion }
    if [llength [info commands PB_CMD_before_motion] ]     { PB_CMD_before_motion }
}


#=============================================================
proc MOM_start_of_group {} {
#=============================================================
  global mom_sys_group_output mom_group_name group_level ptp_file_name
  global mom_sequence_number mom_sequence_increment mom_sequence_frequency
  global mom_sys_ptp_output pb_start_of_program_flag

    if {[regexp NC_PROGRAM $mom_group_name] == 1} {set group_level 0 ; return}

    if {[hiset mom_sys_group_output]} { if {$mom_sys_group_output == "OFF"} {set group_level 0 ; return}}
    if {[hiset group_level]} {incr group_level} else {set group_level 1}
    if {$group_level > 1} {return}

    SEQNO_RESET ; #<4133654>
    MOM_reset_sequence $mom_sequence_number $mom_sequence_increment $mom_sequence_frequency

    if {[info exists ptp_file_name]} {
      MOM_close_output_file $ptp_file_name ; MOM_start_of_program
      if {$mom_sys_ptp_output == "ON"} {MOM_open_output_file $ptp_file_name }
    } else {
      MOM_start_of_program
    }

    PB_start_of_program ; set pb_start_of_program_flag 1
}


#=============================================================
proc PB_CMD_machine_mode { } {
#=============================================================
  global mom_output_mode mom_arc_mode mom_prev_machine_mode mom_machine_mode mom_feed_set_mode
  set mom_output_mode     	"ABSOLUTE"
  set mom_prev_machine_mode  	"TURN"
  set mom_machine_mode 		"TURN" ;
  set mom_arc_mode     		"CIRCULAR" ;
  set mom_feed_set_mode 	"MMPM" ;
}

#=============================================================
proc MOM_machine_mode {} {
#=============================================================
  global pb_start_of_program_flag
  global mom_operation_name mom_sys_change_mach_operation_name

   set mom_sys_change_mach_operation_name $mom_operation_name

    if {$pb_start_of_program_flag == 0} {PB_start_of_program ; set pb_start_of_program_flag 1}
    catch {PB_CMD_machine_mode}
}


#=============================================================
proc PB_FORCE { option args } {
#=============================================================
   if { [info exists option] && [llength $args] } {
      lappend cmd MOM_force
      lappend cmd $option
      lappend cmd [join $args]
      eval { join $cmd }
   }
}


#=============================================================
proc PB_SET_RAPID_MOD { mod_list blk_list ADDR NEW_MOD_LIST } {
#=============================================================
  upvar $ADDR addr
  upvar $NEW_MOD_LIST new_mod_list
  global mom_cycle_spindle_axis traverse_axis1 traverse_axis2


   set new_mod_list [list]

   foreach mod $mod_list {
      switch $mod {
         "rapid1" {
            set elem $addr($traverse_axis1)
            if { [lsearch $blk_list $elem] >= 0 } {
               lappend new_mod_list $elem
            }
         }
         "rapid2" {
            set elem $addr($traverse_axis2)
            if { [lsearch $blk_list $elem] >= 0 } {
               lappend new_mod_list $elem
            }
         }
         "rapid3" {
            set elem $addr($mom_cycle_spindle_axis)
            if { [lsearch $blk_list $elem] >= 0 } {
               lappend new_mod_list $elem
            }
         }
         default {
            set elem $mod
            if { [lsearch $blk_list $elem] >= 0 } {
               lappend new_mod_list $elem
            }
         }
      }
   }
}


########################
# Redefine FEEDRATE_SET
########################
if [llength [info commands ugpost_FEEDRATE_SET] ] {
   rename ugpost_FEEDRATE_SET ""
}

if [llength [info commands FEEDRATE_SET] ] {
   rename FEEDRATE_SET ugpost_FEEDRATE_SET
} else {
   proc ugpost_FEEDRATE_SET {} {}
}


#=============================================================
proc FEEDRATE_SET {} {
#=============================================================
   if [llength [info commands PB_CMD_kin_feedrate_set] ] {
      PB_CMD_kin_feedrate_set
   } else {
      ugpost_FEEDRATE_SET
   }
}


############## EVENT HANDLING SECTION ################


#=============================================================
proc PB_start_of_program { } {
#=============================================================

  if [llength [info commands PB_CMD_kin_start_of_program] ] {
      PB_CMD_kin_start_of_program
  }

  set mom_warning_info "\n   FANUC 18i TB (Tripet TST 250-4R)."
  MOM_output_to_listing_device $mom_warning_info  ;  # MOM_catch_warning ;

  set str "\n :\n"
  append str "\tG01 -  \n"
  append str "\tG17 -   (XY)\n"
  append str "\tG40 -  \n"
  append str "\tG90 -    \n"
  MOM_output_to_listing_device $str  ; #  MOM_catch_warning ;

  set str " - M:\n"
  append str "\tM00 -  (Fanuc-standard)                         M03 -   CW (Fanuc-standard)\n"
  append str "\tM01 -    (Fanuc-standard)              M04 -   CCW (Fanuc-standard)\n"
  append str "\tM02 -   (Fanuc-standard)              M05 -   (Fanuc-standard)\n\n "
  append str "\tM30 -     (Fanuc-standard)  M08 -   ()\n"
  append str "\tM98 -   (Fanuc-standard)           M09 -   ()\n"
  append str "\tM99 -   (Fanuc-standard)\n\n"

  append str "\tM26 -              M93 -     \n"
  append str "\tM27 -               M94 -     \n\n"
  append str "\tM120 -    \n"
  append str "\tM121 -     \n"
  append str "\tM122 -     \n"
  append str "\tM123 -     \n"

  append str "\tDresser -  \n"
  append str "\tM136 - Dresser 1      M152 - Dresser 2       :    \n"
  append str "\tM137 - Dresser 1      M153 - Dresser 2       :    \n"
  append str "\tM138 - Dresser 1      M154 - Dresser 2       :   \n"
  append str "\tM139 - Dresser 1      M155 - Dresser 2       :   \n"
  append str "\tM142 - Dresser 1      M158 - Dresser 2       :  \n"
  append str "\tM143 - Dresser 1      M159 - Dresser 2       :  \n"
  append str "\tM144 - Dresser 1      M160 - Dresser 2       :    CW\n"
  append str "\tM145 - Dresser 1      M161 - Dresser 2       :    CWW\n"
  append str "\tM146 - Dresser 1      M162 - Dresser 2       :    CW\n"
  append str "\tM147 - Dresser 1      M163 - Dresser 2       :    CWW\n"
  append str "\tM148 - Dresser 1      M164 - Dresser 2       :  \n"
  MOM_output_to_listing_device $str  ; #  MOM_catch_warning ;

  set str "  :\n"
  append str "\t%\n"
  append str "\tOxxxx (NAME)\n"
  append str "\tG90 G40 G00\n"
  append str "\tTxx (A1)\n"
  append str "\tM93\n\tM08\n\tG97 M03\\M04 Sxxx\n"
  append str "\tXxx - \n\tZxx\n"
  append str "\tMxx -   \n"
  append str "\t....       .....      ...                  -                            -\n"
  append str "\t....   ...                   |                          | %O4569 (SUB)\n"
  append str "\t....     ...  |              |  G90 G40 G00\n"
  append str "\t....   ...                   | ->    ->|  G41 G1.. F..\n"
  append str "\t....     ...  |           |  ....\n"
  append str "\t....       .....      ...                  -                           |_ G0 G40 X.. Z.. M99\n"
  append str "\tG90 G40\n"
  append str "\tZxx\n\tXxx -   \n"
  append str "\tMxx -    \n"
  append str "\tM09 M05\n"
  append str "\tM94\n"
  append str "\tG225 E1\n"
  append str "\tM02\n"
  MOM_output_to_listing_device $str  ; #  MOM_catch_warning ;

  set str "    :\n"
  append str "\t1 ___ 2\n"
  append str "\t |   |      Tnm , n -   \{1..4\} , m -   \{1..4\}\n"
  append str "\t |___| \n"
  append str "\t3     4 \n"
  MOM_output_to_listing_device $str  ; #  MOM_catch_warning ;

  set str "O"

  global partno_program
  if {[info exists partno_program]} {
    if {$partno_program != ""} { append str $partno_program }
  } else {
    append str "1234"
    #set str [ MOM_ask_unique_filename ]
  }


  global mom_operation_name
  MOM_set_seq_off
  MOM_do_template rewind_stop_code
  MOM_set_seq_on
  set str1  [MOM_string_toupper "$mom_operation_name" ]
  MOM_output_literal "$str ($str1)"
  MOM_force Once G_mode G_cutcom
  MOM_do_template absolute_mode
}


#=============================================================
proc MOM_start_of_path { } {
#=============================================================
  global first_linear_move ; set first_linear_move 0
   TOOL_SET MOM_start_of_path

   if [llength [info commands PB_CMD_kin_start_of_path] ] {
      PB_CMD_kin_start_of_path
   }

}


#=============================================================
proc MOM_from_move { } {
#=============================================================
  global mom_feed_rate mom_feed_rate_per_rev  mom_motion_type mom_kin_max_fpm
   COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET
}


#=============================================================
proc MOM_first_tool { } {
#=============================================================
  global mom_tool_change_type mom_manual_tool_change

   PB_TURRET_HEAD_SET

   MOM_output_literal "M225 E1"

   if {[info exists mom_tool_change_type]} {
      switch $mom_tool_change_type {
         MANUAL { PB_manual_tool_change }
         AUTO   { PB_auto_tool_change }
      }
   } elseif {[info exists mom_manual_tool_change]} {
      if {$mom_manual_tool_change == "TRUE"} {
         PB_manual_tool_change
      }
   }
}


#=============================================================
proc PB_auto_tool_change { } {
#=============================================================
   PB_CMD_alignment_block
   PB_CMD_start_of_alignment_character
   MOM_force Once T M
   MOM_do_template auto_tool_change
   PB_CMD_end_of_alignment_character
}


#=============================================================
proc PB_manual_tool_change { } {
#=============================================================
   PB_CMD_alignment_block
   MOM_do_template stop
   PB_CMD_start_of_alignment_character
   MOM_force Once T
   MOM_do_template manual_tool_change_1
   PB_CMD_end_of_alignment_character
}


#=============================================================
proc MOM_initial_move { } {
#=============================================================
  global mom_feed_rate mom_feed_rate_per_rev mom_motion_type
  global mom_kin_max_fpm mom_motion_event
   COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET

   MOM_output_literal "M08"
   MOM_output_literal "M93"

   PB_CMD_spindle_sfm_prestart

  global mom_programmed_feed_rate
   if { [EQ_is_equal $mom_programmed_feed_rate 0] } {
      MOM_rapid_move
   } else {
      MOM_linear_move
   }
}


#=============================================================
proc MOM_first_move { } {
#=============================================================
  global mom_feed_rate mom_feed_rate_per_rev mom_motion_type
  global mom_kin_max_fpm mom_motion_event
   COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET
   PB_CMD_spindle_sfm_prestart
   catch {MOM_$mom_motion_event}
}


#=============================================================
proc PB_approach_move { } {
#=============================================================
}


#=============================================================
proc PB_engage_move { } {
#=============================================================
}


#=============================================================
proc PB_first_cut { } {
#=============================================================
}


#=============================================================
proc PB_first_linear_move { } {
#=============================================================
   PB_CMD_output_spindle
}


#=============================================================
proc PB_return_move { } {
#=============================================================
}


#=============================================================
proc MOM_gohome_move { } {
#=============================================================
   MOM_force ONCE G_cutcom ; #G_mode
   MOM_do_template absolute_mode
   MOM_rapid_move
}


#=============================================================
proc MOM_end_of_path { } {
#=============================================================

   if [llength [info commands PB_CMD_kin_end_of_path] ] {
      PB_CMD_kin_end_of_path
   }

}


#=============================================================
proc MOM_end_of_program { } {
#=============================================================

   MOM_do_template end_of_path
   MOM_output_literal "M94"
   MOM_output_literal "G225 E2"
   MOM_do_template end_of_program
   MOM_set_seq_off
   MOM_do_template rewind_stop_code

#**** The following procedure lists the tool list with time in commentary data
   LIST_FILE_TRAILER

#**** The following procedure closes the warning and listing files
   CLOSE_files
}


#=============================================================
proc MOM_tool_change { } {
#=============================================================
  global mom_tool_change_type mom_manual_tool_change
   PB_TURRET_HEAD_SET
   if {[info exists mom_tool_change_type]} {
      switch $mom_tool_change_type {
         MANUAL { PB_manual_tool_change }
         AUTO   { PB_auto_tool_change }
      }
   } elseif {[info exists mom_manual_tool_change]} {
      if {$mom_manual_tool_change == "TRUE"} {
         PB_manual_tool_change
      }
   }
}


#=============================================================
proc MOM_length_compensation { } {
#=============================================================
   TOOL_SET MOM_length_compensation
   MOM_do_template tool_length_adjust
}


#=============================================================
proc MOM_set_modes { } {
#=============================================================
   MODES_SET
}


#=============================================================
proc MOM_spindle_rpm { } {
#=============================================================
   SPINDLE_SET
}


#=============================================================
proc MOM_spindle_css { } {
#=============================================================
   SPINDLE_SET
}


#=============================================================
proc MOM_spindle_off { } {
#=============================================================
   MOM_do_template spindle_off
}


#=============================================================
proc MOM_coolant_on { } {
#=============================================================
   COOLANT_SET
   MOM_do_template coolant_on
}


#=============================================================
proc MOM_coolant_off { } {
#=============================================================
   COOLANT_SET
   MOM_do_template coolant_off
}


#=============================================================
proc PB_feedrates { } {
#=============================================================
}


#=============================================================
proc MOM_cutcom_on { } {
#=============================================================
   CUTCOM_SET
   MOM_do_template cutcom_on
}


#=============================================================
proc MOM_cutcom_off { } {
#=============================================================
   CUTCOM_SET
   MOM_do_template cutcom_off
}


#=============================================================
proc MOM_delay { } {
#=============================================================
  global mom_sys_delay_param mom_delay_value
  global mom_delay_revs mom_delay_mode delay_time

   # post builder provided format for the current mode:
    if {[info exists mom_sys_delay_param(${mom_delay_mode},format)] != 0} {
      MOM_set_address_format dwell $mom_sys_delay_param(${mom_delay_mode},format)
    }

    switch $mom_delay_mode {
      SECONDS {set delay_time $mom_delay_value}
      default {set delay_time $mom_delay_revs}
    }

   MOM_do_template delay
}


#=============================================================
proc MOM_opstop { } {
#=============================================================
   MOM_do_template opstop
}


#=============================================================
proc MOM_auxfun { } {
#=============================================================
   MOM_do_template auxfun
}


#=============================================================
proc MOM_prefun { } {
#=============================================================
   MOM_do_template prefun
}


#=============================================================
proc MOM_load_tool { } {
#=============================================================
  global mom_tool_change_type mom_manual_tool_change
   PB_TURRET_HEAD_SET
}


#=============================================================
proc MOM_stop { } {
#=============================================================
   MOM_do_template stop
}


#=============================================================
proc MOM_tool_preselect { } {
#=============================================================
  global mom_tool_preselect_number mom_tool_number mom_next_tool_number
   if {[info exists mom_tool_preselect_number]} {
      set mom_next_tool_number $mom_tool_preselect_number
   }
}


#=============================================================
proc MOM_linear_move { } {
#=============================================================
  global feed_mode mom_feed_rate mom_kin_rapid_feed_rate

   if { $feed_mode == "IPM" || $feed_mode == "MMPM" } {
      if { [EQ_is_ge $mom_feed_rate $mom_kin_rapid_feed_rate] } {
         MOM_rapid_move ; return
      }
   }

  global first_linear_move

   if {!$first_linear_move} { PB_first_linear_move ; incr first_linear_move }

   MOM_do_template linear_move
}


#=============================================================
proc MOM_circular_move { } {
#=============================================================
   MOM_do_template circular_move
}


#=============================================================
proc MOM_rapid_move { } {
#=============================================================
  global rapid_spindle_inhibit rapid_traverse_inhibit
  global spindle_first is_from
  global mom_cycle_spindle_axis traverse_axis1 traverse_axis2
  global mom_motion_event

   set aa(0) X ; set aa(1) Y ; set aa(2) Z
   RAPID_SET
   MOM_do_template rapid_move
}


#=============================================================
proc MOM_sequence_number { } {
#=============================================================
   SEQNO_SET
}


proc  MOM_text {} {
#_______________________________________________________________________________
# This procedure is executed when the Text command is activated.
#_______________________________________________________________________________
  global mom_user_defined_text
  global mom_record_fields mom_field_count mom_record_text
  global mom_sys_control_out mom_sys_control_in
  global mom_Instruction
  global mom_operator_message mom_operator_message_defined
  global mom_pprint_defined mom_pprint
  global mom_warning_info
  global mom_operation_name

  switch [string toupper $mom_record_fields(0)] {
   "SET"  { ; }
  "INSERT" {
           if {[info exists mom_record_fields(1)]}  {
              set mom_Instruction [string toupper $mom_record_text ] ; #$mom_record_fields(1)] ;
              MOM_insert
           }
         }
  "DISPLY" {
             set mom_operator_message_defined 1
             set mom_operator_message $mom_record_text
             MOM_operator_message
           }
  "PPRINT" {
           set mom_pprint_defined 1
           set mom_pprint $mom_record_text
           MOM_pprint
          }
  "PARTNO" { ; #   ()
           global partno_program
           set partno_program  "" ;
           set str "User Defined"
           if {[info exists  mom_record_fields(1)]} {
             set partno_program $mom_record_text ; # $mom_record_fields(1)
           }  else  {
              set RNseed [clock clicks] ;
              set RNseed [expr (30903 * ($RNseed & 65535) + ($RNseed>>16))]
              set RNseed [expr (($RNseed & 65535)/65535.0)]
              set RNseed [expr $RNseed*100000.0]
              set RNseed [expr int($RNseed)]
              set partno_program [format "%4d" $RNseed]
              set str "."
           }
           set mom_warning_info "\n<!--\n PARTNO-> \[  () - !   \]=$partno_program ($str)\n-->"
           MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
         }
  "REWIND" { ; #  
           }
  "SLOWDN" {  ; #    
          }
  "TIME" { ; #  
         }
  default {
           if {[info exists mom_user_defined_text]} {
             MOM_output_literal "${mom_sys_control_out}${mom_user_defined_text}${mom_sys_control_in}"
             set mom_warning_info "\nWARNING:   !($mom_user_defined_text)"
             MOM_output_to_listing_device $mom_warning_info ; MOM_catch_warning ;
           }
         }

  }

}


proc  MOM_insert {} {
#_______________________________________________________________________________
# This procedure is executed when the Insert command is activated.
#_______________________________________________________________________________
   global mom_Instruction
   MOM_output_literal "$mom_Instruction"
   global mom_warning_info
   set mom_warning_info "\n<!--\n INSERT-> \[ \]=$mom_Instruction\n-->\nWARNING:    'INSERT/$mom_Instruction' -  \n"
   MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}


proc  MOM_pprint {} {
#_______________________________________________________________________________
# This procedure is executed when the PPrint command is activated.
#_______________________________________________________________________________
 global mom_pprint_defined  mom_pprint
 global mom_warning_info  mom_operation_name
 global mom_sys_control_out mom_sys_control_in

 if {[info exists mom_pprint]} {
  if {$mom_pprint!=""} {
       set str [ MOM_string_toupper $mom_pprint ]
       MOM_output_literal "${mom_sys_control_out}${str}${mom_sys_control_in}"
   }
 }

}


proc MOM_operator_message {} {
#_______________________________________________________________________________
# This procedure is executed when the Operator Message command is activated.
#_______________________________________________________________________________
 global mom_operator_message  mom_operator_message_defined
 global mom_warning_info  mom_operation_name
 global mom_sys_control_out mom_sys_control_in

  if {[info exists mom_operator_message]} {
    if {$mom_operator_message!=""} {
       set str [ MOM_string_toupper $mom_operator_message ]
       MOM_output_text "${mom_sys_control_out}${str}${mom_sys_control_in}"
     }
   }

}


##############################################################CYCLES


#=============================================================
proc MOM_lathe_thread { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name LATHE_THREAD

  global mom_warning_info
  set mom_warning_info "\nWARNING:  LATHE_THREAD   \n     Point-to-Point\n"
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}


#=============================================================
proc MOM_lathe_thread_move { } {
#=============================================================
  global cycle_init_flag

   MOM_do_template thread_move
   set cycle_init_flag FALSE
   MOM_linear_move
}


#=============================================================
proc MOM_cycle_off { } {
#=============================================================
  global cycle_name
  MOM_force once G_motion F
  set cycle_name OFF
}

#=============================================================
proc MOM_cycle_plane_change { } {
#=============================================================
  global cycle_init_flag
  set cycle_init_flag TRUE

}


#=============================================================
proc MOM_drill { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL
   CYCLE_SET

  global mom_warning_info
  set mom_warning_info "\nWARNING:  DRILL   \n     Point-to-Point\n"
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}


#=============================================================
proc MOM_drill_move { } {
#=============================================================
  global cycle_init_flag
  set cycle_init_flag FALSE
  MOM_linear_move
}


#=============================================================
proc MOM_drill_dwell { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL_DWELL
   CYCLE_SET

  global mom_warning_info
  set mom_warning_info "\nWARNING:  DRILL_DWELL   \n     Point-to-Point\n"
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}


#=============================================================
proc MOM_drill_dwell_move { } {
#=============================================================
   global cycle_init_flag
   set cycle_init_flag FALSE
   MOM_linear_move
}


#=============================================================
proc MOM_drill_deep { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL_DEEP
   CYCLE_SET

  global mom_warning_info
  set mom_warning_info "\nWARNING:  DRILL_DEEP   \n     Point-to-Point\n"
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}


#=============================================================
proc MOM_drill_deep_move { } {
#=============================================================
   global cycle_init_flag
   set cycle_init_flag FALSE
   MOM_linear_move
}

#=============================================================
proc MOM_drill_break_chip { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL_BREAK_CHIP
   CYCLE_SET

  global mom_warning_info
  set mom_warning_info "\nWARNING:  DRILL_BREAK_CHIP   \n     Point-to-Point\n"
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}

#=============================================================
proc MOM_drill_break_chip_move { } {
#=============================================================
   global cycle_init_flag
   set cycle_init_flag FALSE
   MOM_linear_move
}

#=============================================================
proc MOM_drill_peck { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL
   CYCLE_SET

  global mom_warning_info
  set mom_warning_info "\nWARNING:  DRILL_PECK   \n     Point-to-Point\n"
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}

#=============================================================
proc MOM_drill_peck_move { } {
#=============================================================
   global cycle_init_flag
   set cycle_init_flag FALSE
   MOM_linear_move
}

#=============================================================
proc MOM_tap { } {
#=============================================================
  global cycle_name
  global cycle_init_flag
   set cycle_init_flag TRUE
   set cycle_name TAP
   CYCLE_SET

  global mom_warning_info
  set mom_warning_info "\nWARNING:  TAP   \n     Point-to-Point\n"
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}

#=============================================================
proc MOM_tap_move { } {
#=============================================================
   global cycle_init_flag
   set cycle_init_flag FALSE
   MOM_linear_move
}


#=============================================================
proc MOM_bore { } {
#=============================================================
  global cycle_name
  global cycle_init_flag
   set cycle_init_flag TRUE
   set cycle_name BORE
   CYCLE_SET

  global mom_warning_info
  set mom_warning_info "\nWARNING:       \[bore\]\n     Point-to-Point\n"
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}


#=============================================================
proc MOM_bore_move { } {
#=============================================================
  global cycle_init_flag
  set cycle_init_flag FALSE
  MOM_linear_move
}


#=============================================================
proc MOM_bore_drag { } {
#=============================================================
  global cycle_name
  global cycle_init_flag
   set cycle_init_flag TRUE
   set cycle_name BORE_DRAG
   CYCLE_SET

  global mom_warning_info
  set mom_warning_info "\nWARNING:  BORE_DRAG   \n     Point-to-Point\n"
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}


#=============================================================
proc MOM_bore_drag_move { } {
#=============================================================
  global cycle_init_flag
  set cycle_init_flag FALSE
  MOM_linear_move
}


#=============================================================
proc MOM_bore_no_drag { } {
#=============================================================
  global cycle_name
  global cycle_init_flag
  set cycle_init_flag TRUE
  set cycle_name BORE_NO_DRAG
  CYCLE_SET

  global mom_warning_info
  set mom_warning_info "\nWARNING:   C   \[bore_no_drag\]    \n     Point-to-Point\n"
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}


#=============================================================
proc MOM_bore_no_drag_move { } {
#=============================================================
  global cycle_init_flag
  set cycle_init_flag FALSE
  MOM_linear_move
}


#=============================================================
proc MOM_bore_manual { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

  set cycle_init_flag TRUE
  set cycle_name BORE_MANUAL
  CYCLE_SET

  global mom_warning_info
  set mom_warning_info "\nWARNING:  BORE_MANUAL   \n     Point-to-Point\n"
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}


#=============================================================
proc MOM_bore_manual_move { } {
#=============================================================
  global cycle_init_flag
  set cycle_init_flag FALSE
  MOM_linear_move
}


#=============================================================
proc MOM_bore_dwell { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

  set cycle_init_flag TRUE
  set cycle_name BORE_DWELL
  CYCLE_SET

  global mom_warning_info
  set mom_warning_info "\nWARNING:  BORE_DWELL   \n     Point-to-Point\n"
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}


#=============================================================
proc MOM_bore_dwell_move { } {
#=============================================================
  global cycle_init_flag
  set cycle_init_flag FALSE
  MOM_linear_move
}


#=============================================================
proc MOM_bore_back { } {
#=============================================================
  global cycle_name ;    set cycle_name BORE_BACK
  global cycle_init_flag ;  set cycle_init_flag TRUE
    CYCLE_SET

  global mom_warning_info
  set mom_warning_info "\nWARNING:    \[bore_back\]    \n     Point-to-Point\n"
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}


#=============================================================
proc MOM_bore_back_move { } {
#=============================================================
  global cycle_init_flag
  set cycle_init_flag FALSE
  MOM_linear_move
}


#=============================================================
proc MOM_bore_manual_dwell { } {
#=============================================================
  global cycle_name ;     set cycle_name BORE_MANUAL_DWELL
  global cycle_init_flag ;   set cycle_init_flag TRUE
  CYCLE_SET

  global mom_warning_info
  set mom_warning_info "\nWARNING:  BORE_MANUAL_DWELL   \n     Point-to-Point\n"
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}


#=============================================================
proc MOM_bore_manual_dwell_move { } {
#=============================================================
  global cycle_init_flag ;
  MOM_do_template cycle_bore_manual_dwell
  set cycle_init_flag FALSE
}

############################################################################################################################

#=============================================================
proc PB_TURRET_HEAD_SET { } {
#=============================================================
  global mom_kin_independent_head mom_tool_head
  global turret_current mom_warning_info

    set turret_current INDEPENDENT

    if {$mom_tool_head != $mom_kin_independent_head} {
      set turret_current DEPENDENT
    }

    if {$mom_tool_head != "NONE" && \
         $mom_tool_head != "NONE"} {
      set mom_warning_info "$mom_tool_head IS INVALID, USING NONE"
      MOM_catch_warning
    }
}


#=============================================================
proc PB_CMD_alignment_block { } {
#=============================================================
  MOM_force once X Z M_spindle M_coolant F G_feed
}


#=============================================================
proc PB_CMD_before_motion { } {
#=============================================================

}


#=============================================================
proc PB_CMD_end_of_alignment_character { } {
#=============================================================
 #  Return sequnece number back to orignal
 #  This command may be used with the command "PM_CMD_start_of_alignment_character"

  global mom_sys_leader saved_seq_num
  #set mom_sys_leader(N) $saved_seq_num
}


#=============================================================
proc PB_CMD_kin_feedrate_set { } {
#=============================================================
# This procedure supercedes the functionalites provided by the
# FEEDRATE_SET in ugpost_base.tcl.  Post Builder automatically
# generates proper call sequences to this procedure in the
# Event handlers.
#
# This procedure must be used in conjunction with ugpost_base.tcl.
#
  global   feed com_feed_rate
  global   mom_feed_rate_output_mode super_feed_mode feed_mode
  global   mom_cycle_feed_rate_mode mom_cycle_feed_rate
  global   mom_cycle_feed_rate_per_rev
  global   mom_motion_type
  global   mom_warning_info
  global   Feed_IPM Feed_IPR Feed_MMPM Feed_MMPR Feed_INV
  global   mom_sys_feed_param
  global   mom_sys_cycle_feed_mode


  set super_feed_mode $mom_feed_rate_output_mode

  set f_pm [ASK_FEEDRATE_FPM] ; set f_pr [ASK_FEEDRATE_FPR]

  switch $mom_motion_type {

    CYCLE {
      if [info exists mom_sys_cycle_feed_mode] {
         if { $mom_sys_cycle_feed_mode != "Auto" } {
            set mom_cycle_feed_rate_mode $mom_sys_cycle_feed_mode
         }
      }
      if {[hiset mom_cycle_feed_rate_mode]} { set super_feed_mode $mom_cycle_feed_rate_mode }
      if {[hiset mom_cycle_feed_rate]} { set f_pm $mom_cycle_feed_rate }
      if {[hiset mom_cycle_feed_rate_per_rev]} { set f_pr $mom_cycle_feed_rate_per_rev }
    }

    FROM -
    RETRACT -
    RETURN -
    LIFT -
    TRAVERSAL -
    GOHOME -
    GOHOME_DEFAULT -
    RAPID {
      SUPER_FEED_MODE_SET RAPID
    }

    default {
      if {[EQ_is_zero $f_pm] && [EQ_is_zero $f_pr]} {
        SUPER_FEED_MODE_SET RAPID
      } else {
        SUPER_FEED_MODE_SET CONTOUR
      }
    }
  }


  set feed_mode $super_feed_mode


 # Adjust feedrate format per Post output unit again.
  global mom_kin_output_unit
  if { $mom_kin_output_unit == "IN" } {
     switch $feed_mode {
       MMPM {
         set feed_mode "IPM"
         CATCH_WARNING "Feedrate mode MMPM changed to IPM"
       }
       MMPR {
         set feed_mode "IPR"
         CATCH_WARNING "Feedrate mode MMPR changed to IPR"
       }
     }
  } else {
     switch $feed_mode {
       IPM {
         set feed_mode "MMPM"
         CATCH_WARNING "Feedrate mode IPM changed to MMPM"
       }
       IPR {
         set feed_mode "MMPR"
         CATCH_WARNING "Feedrate mode IPR changed to MMPR"
       }
     }
  }


  switch $feed_mode {
    IPM     -
    MMPM    { set feed $f_pm }
    IPR     -
    MMPR    { set feed $f_pr }
    DPM     { set feed [PB_CMD_FEEDRATE_DPM] }
    FRN     -
    INVERSE { set feed [PB_CMD_FEEDRATE_NUMBER] }
    default { set mom_warning_info "INVALID FEED RATE MODE" ; MOM_catch_warning ; return }
  }


 # Post Builder provided format for the current mode:
  if [info exists mom_sys_feed_param(${feed_mode},format)] {
    MOM_set_address_format F $mom_sys_feed_param(${feed_mode},format)
  } else {
    switch $feed_mode {
      IPM     -
      MMPM    -
      IPR     -
      MMPR    -
      DPM     -
      FRN     { MOM_set_address_format F Feed_${feed_mode} }
      INVERSE { MOM_set_address_format F Feed_INV }
    }
  }

 # Commentary output
  set com_feed_rate $f_pm


 # Execute user's commnad, if any.
  if [llength [info commands "PB_CMD_FEEDRATE_SET"]] {
     PB_CMD_FEEDRATE_SET
  }
}


#=============================================================
proc PB_CMD_kin_start_of_path { } {
#=============================================================
#
#  This procedure is executed at the start of every operation.
#  It will check to see if a new head (post) was loaded and
#  will then initialize any functionality specific to that post.
#
#  It will also restore the initial Start of Program or End
#  of program event procedures.
#
#  DO NOT CHANGE THIS FILE UNLESS YOU KNOW WHAT YOU ARE DOING.
#  DO NOT CALL THIS PROCEDURE FROM ANY OTHER CUSTOM COMMAND.
#

  global mom_sys_head_change_init_program

   if [info exists mom_sys_head_change_init_program] {

      PB_CMD_kin_start_of_program
      unset mom_sys_head_change_init_program

      if [llength [info commands "MOM_start_of_program_save"]] {
         rename MOM_start_of_program ""
         rename MOM_end_of_program ""
         rename MOM_start_of_program_save MOM_start_of_program
         rename MOM_end_of_program_save MOM_end_of_program
      }
   }
}


#=============================================================
proc PB_CMD_kin_start_of_program { } {
#=============================================================
#
#  This procedure will execute the following custom commands for
#  initialization.  They will be executed once at the start of
#  program and again each time they are loaded as a linked post.
#  After execution they will be deleted so that they are not
#  present when a different post is loaded.  You may add a call
#  to a procedure that you want executed when a linked post is
#  loaded.
#
#  Note that when a linked post is called in, the Start of Program
#  event marker is not executed again, only this procedure.
#
#  DO NOT REMOVE ANY LINES FROM THIS PROCEDURE UNLESS YOU KNOW
#  WHAT YOU ARE DOING.  DO NOT CALL THIS PROCEDURE FROM ANY
#  OTHER CUSTOM COMMAND.
#

   set command_list [list]
   lappend command_list  PB_CMD_multiple_post_initialize
   lappend command_list  PB_CMD_init_multiple_post
   lappend command_list  PB_CMD_initialize_tool_list
   lappend command_list  PB_CMD_init_tool_list
   lappend command_list  PB_CMD_init_tape_break

   foreach cmd $command_list {

      if [llength [info commands "$cmd"]] {
         $cmd
         rename $cmd ""
         proc $cmd { args } {}
      }
   }
}


#=============================================================
proc PB_CMD_output_spindle { } {
#=============================================================
  global mom_spindle_mode

  if {$mom_spindle_mode == "RPM"} {
     MOM_force once M_spindle S G_spin
     MOM_do_template spindle_rpm
  } elseif {$mom_spindle_mode == "SFM" || $mom_spindle_mode == "SMM"} {
     MOM_force once M_spindle S G G_spin
     MOM_do_template spindle_max_rpm
     MOM_do_template spindle_css
  }
}


#=============================================================
proc PB_CMD_spindle_sfm_prestart { } {
#=============================================================
  global mom_spindle_mode

  if {$mom_spindle_mode == "SFM" || $mom_spindle_mode == "SMM"} {
     MOM_force once G_spin M_spindle S
     MOM_do_template spindle_rpm_preset
  }
  MOM_output_literal "M26 M122 (MODE COOLANT)"
}


#=============================================================
proc PB_CMD_start_of_alignment_character { } {
#=============================================================
 # This command can be used to output a special sequence number character.
 # Replace the ":" with any character that you require.
 # You must use the command "PB_CMD_end_of_alignment_character" to reset
 # the sequence number back to the original setting.

  global mom_sys_leader saved_seq_num
  set saved_seq_num $mom_sys_leader(N)
  #set mom_sys_leader(N) ":"
}


#=============================================================
proc CATCH_WARNING { msg } {
#=============================================================
  global mom_warning_info
  global mom_motion_event
  global mom_event_number

   set level [info level]
   set call_stack ""
   for {set i 1} {$i < $level} {incr i} {
      set call_stack "$call_stack\[ [lindex [info level $i] 0] \]"
   }
   set mom_warning_info "$msg ($mom_motion_event $mom_event_number)" ; # $call_stack"
   MOM_catch_warning
}


#=============================================================
proc WORKPLANE_SET {  } {
#=============================================================
   global mom_cycle_spindle_axis
   global mom_sys_spindle_axis
   global traverse_axis1 traverse_axis2

   if { ![info exists mom_sys_spindle_axis] } {
      set mom_sys_spindle_axis(0) 0.0
      set mom_sys_spindle_axis(1) 0.0
      set mom_sys_spindle_axis(2) 1.0
   }

   if { ![info exists mom_cycle_spindle_axis] } {
      set x $mom_sys_spindle_axis(0)
      set y $mom_sys_spindle_axis(1)
      set z $mom_sys_spindle_axis(2)

      if { [EQ_is_zero $y] && [EQ_is_zero $z] } {
         set mom_cycle_spindle_axis 0
      } elseif { [EQ_is_zero $x] && [EQ_is_zero $z] } {
         set mom_cycle_spindle_axis 1
      } else {
         set mom_cycle_spindle_axis 2
      }
   }

   if { $mom_cycle_spindle_axis == 2 } {
      set traverse_axis1 0 ; set traverse_axis2 1
   } elseif { $mom_cycle_spindle_axis == 0 } {
      set traverse_axis1 1 ; set traverse_axis2 2
   } elseif { $mom_cycle_spindle_axis == 1 } {
      set traverse_axis1 0 ; set traverse_axis2 2
   }
}




if [info exists mom_sys_start_of_program_flag] {
   if [llength [info commands PB_CMD_kin_start_of_program] ] {
      PB_CMD_kin_start_of_program
   }
} else {
   set mom_sys_head_change_init_program 1
   set mom_sys_start_of_program_flag 1
}



#***************************
# Source in user's tcl file.
#***************************
 set user_tcl_file ${cam_post_dir}tripet_tst_250_4r_user.tcl
 if { [file exists $user_tcl_file] } {
    source $user_tcl_file
 }


